const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_badges = sequelize.define(
    'user_badges',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

awarded_at: {
        type: DataTypes.DATE,
      
      

      },

award_reason: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_badges.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.user_badges.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.user_badges.belongsTo(db.gamification_badges, {
      as: 'badge',
      foreignKey: {
        name: 'badgeId',
      },
      constraints: false,
    });




    db.user_badges.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_badges.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_badges;
};


